//+------------------------------------------------------------------+
//|                                 Expert file, Forex_Nn_Expert.mq4 |
//|                                                                  |
//|                                 v1.0  added MoneyManagement      |
//|                                             AccountIsMini        |
//|                                                                  |      
//|                                                                  |   
//+------------------------------------------------------------------+

//http://www.forex-tsd.com/expert-advisors-metatrader-4/11087-how-build-nn-ea-mt4.html
#property copyright "S.Projects"
#property link "cortex.snowcron.com"

extern double dBuyLevel = 0.21;
extern double dSellLevel=0.9;
extern double dStopLoss = 100;
extern double dTrailingStop=40;

//+---------------------------------------------------+
//|Account functions                                  |
//+---------------------------------------------------+
extern bool    AccountIsMini = true;   // Change to true if trading mini account
//+---------------------------------------------------+
//|Money Management                                   |
//+---------------------------------------------------+
extern bool    MoneyManagement = true; // Change to false to shutdown money management controls.
                                       // Lots = 0.1 will be in effect and only 0.1 lot will be open regardless of equity.
extern double  TradeSizePercent = 10;  // Change to whatever percent of equity you wish to risk.
extern double  Lots = 0.1;             // standard lot size. 
extern double  MaxLots = 100;

// ------

extern double dTakeProfit = 0;

datetime timePrev = 0;
int nBars;
int nSlip = 5;

//extern double dLotSize = 0.1;
extern double dLotSize;
int nMagic = 0;

string strExpert = "forex_nn";

// ------

int init ()
{
    nBars = Bars;

    if(Symbol() == "EURUSD" && Period() == 60)
    {
        //if(!IsTesting())                    
        //{
            dBuyLevel = 0.21;        
            dSellLevel = 0.9;
                                    
            dStopLoss = 200 * Point;        
            dTrailingStop = 200 * Point;
        }
        else
        {
            dStopLoss = dStopLoss * Point;
            dTrailingStop = dTrailingStop * Point;
       // }
        
        nMagic = 0;
    }

    return(0);
}
// ------
int deinit()
{
    return(0);
}

// ------

int start()
{
    if(Bars < 200)
        return(0);
    
    if(!IsBarEnd())
        return(0);
    
    // ------
    
    if(MoneyManagement) {dLotSize = GetLots();} else {dLotSize = Lots;}
    
    double dNoc = iCustom(NULL, 0, "Forex_Nn_Ind", 1, 1);
    double dNocPrev = iCustom(NULL, 0, "Forex_Nn_Ind", 1, 2);
        
    for(int nCnt = OrdersTotal() - 1; nCnt >= 0; nCnt--)
    {
        OrderSelect(nCnt, SELECT_BY_POS, MODE_TRADES);
        if(OrderMagicNumber() == nMagic)
        {
            if(OrderType() == OP_BUY)
            {         
                if(dNocPrev >= dSellLevel && dNoc <= dSellLevel)
                {
                    OrderClose(OrderTicket(), 
                        OrderLots(), Bid, nSlip, Aqua);
                    break;
                }
            }
            else if(OrderType() == OP_SELL)
            {
                if(dNocPrev <= dBuyLevel && dNoc >= dBuyLevel)
                {
                    OrderClose(OrderTicket(), 
                        OrderLots(), Ask, nSlip, OrangeRed);
                    break;
                }
            }
        }
    }

    int nNumOfOpenedOrders = 0;
    for(nCnt = OrdersTotal() - 1; nCnt >= 0; nCnt--)
    {
        OrderSelect(nCnt, SELECT_BY_POS, MODE_TRADES);
        if(OrderMagicNumber() == nMagic)
            nNumOfOpenedOrders++;
    }

    if(nNumOfOpenedOrders == 0)
    {
    if(dNocPrev <= dBuyLevel && dNoc >= dBuyLevel) 
        //if(dNocPrev >= dBuyLevel && dNoc >= dBuyLevel) 
        {
            OrderSend(Symbol(), OP_BUY, dLotSize, Ask, 
                nSlip, Ask - dStopLoss, 0, strExpert, 
                nMagic, 0, Aqua);
        }
        else if(dNocPrev >= dSellLevel && dNoc <= dSellLevel) 
        //else if(dNocPrev <= dSellLevel && dNoc <= dSellLevel) 
        {
            OrderSend(Symbol(), OP_SELL, dLotSize, Bid, 
                nSlip, Bid + dStopLoss, 0, strExpert, 
                nMagic, 0, OrangeRed);
        }
    }
        
    // ------

    ModifyOrders();
    
    // ------
    
    return(0);
}


// ------

void ModifyOrders()
{
    for(int nCnt = 0; nCnt < OrdersTotal(); nCnt++)
    {
        OrderSelect(nCnt, SELECT_BY_POS, MODE_TRADES);
        if(OrderMagicNumber() == nMagic)
        {
            if(OrderType() == OP_BUY)
            {
                if(OrderStopLoss() < Bid - dTrailingStop - 5 * Point)
                {
                    OrderModify(OrderTicket(), OrderOpenPrice(), 
                        Bid - dTrailingStop, OrderTakeProfit(), 0, Aqua);
                    break;
                }
            }
            
            if(OrderType() == OP_SELL)
            {
                if(OrderStopLoss() > Ask + dTrailingStop + 5 * Point)
                {
                    OrderModify(OrderTicket(), OrderOpenPrice(), 
                        Ask + dTrailingStop, OrderTakeProfit(), 
                        0, OrangeRed);
                    break;
                }
            }
        }
    }
}

// ------

bool IsBarEnd()
{
    bool bIsBarEnd = false;
    if(nBars != Bars)
    {
        bIsBarEnd = true;
        nBars = Bars;
    }
    
    return(bIsBarEnd);
}

//+------------------------------------------------------------------+
//| Get number of lots for this trade                                |
//+------------------------------------------------------------------+
double GetLots()
{
   double lot;
   
   if(MoneyManagement)
   {
     lot = LotsOptimized();
   }
   else
   {
     lot = Lots;
   }
   
   if(AccountIsMini)
   {
     if (lot < 0.1) lot = 0.1;
   }
   else
   {
     if (lot >= 1.0) lot = MathFloor(lot); else lot = 1.0;
   }
   if (lot > MaxLots) lot = MaxLots;
   
   return(lot);
}

//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+

double LotsOptimized()
  {
   double lot=Lots;
//---- select lot size
   lot=NormalizeDouble(MathFloor(AccountFreeMargin()*TradeSizePercent/10000)/10,1);
   
  
  // lot at this point is number of standard lots
  
//  if (Debug) Print ("Lots in LotsOptimized : ",lot);
  
  // Check if mini or standard Account
  
  if(AccountIsMini)
  {
    lot = MathFloor(lot*10)/10;
    
   }
   return(lot);
  }

